<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::sds Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html">sds</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#nested-classes">Classes</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#enum-members">Enumerations</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::sds Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1test"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1test.html">test</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html">InProcessSDSTraits</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Structure for specifying the traits of a <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a> which works between threads in a single process.  <a href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:a269866d267e8991328744c2e662931d2"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a269866d267e8991328744c2e662931d2">InProcessSDS</a> = <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a>&lt; <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html">InProcessSDSTraits</a> &gt;</td></tr>
<tr class="memdesc:a269866d267e8991328744c2e662931d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Type alias for a <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a> which works between threads in a single process.  <a href="#a269866d267e8991328744c2e662931d2">More...</a><br /></td></tr>
<tr class="separator:a269866d267e8991328744c2e662931d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:a07d2a9441f40d089a1f9a0d7e2baab4b"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">ReaderPolicy</a> { <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4ba96aa07a625aac998fe9bd5cfd36a6880">ReaderPolicy::NONBLOCKING</a>, 
<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4ba72323e5457d8fb855145bfee934aa415">ReaderPolicy::BLOCKING</a>
 }</td></tr>
<tr class="memdesc:a07d2a9441f40d089a1f9a0d7e2baab4b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Specifies the policy to use for reading from the stream.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">More...</a><br /></td></tr>
<tr class="separator:a07d2a9441f40d089a1f9a0d7e2baab4b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b17d768f16a6f5da766df780d94bbd5"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">WriterPolicy</a> { <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5ad834d04fd76eafde1c8b4f6f95bdfdf8">WriterPolicy::NONBLOCKABLE</a>, 
<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5a5d027622828a53a8fc66dd131952c8a1">WriterPolicy::ALL_OR_NOTHING</a>, 
<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5a72323e5457d8fb855145bfee934aa415">WriterPolicy::BLOCKING</a>
 }</td></tr>
<tr class="memdesc:a7b17d768f16a6f5da766df780d94bbd5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Specifies the policy to use for writing to the stream.  <a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">More...</a><br /></td></tr>
<tr class="separator:a7b17d768f16a6f5da766df780d94bbd5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Typedef Documentation</h2>
<a id="a269866d267e8991328744c2e662931d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a269866d267e8991328744c2e662931d2">&#9670;&nbsp;</a></span>InProcessSDS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a269866d267e8991328744c2e662931d2">alexaClientSDK::avsCommon::utils::sds::InProcessSDS</a> = typedef <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a>&lt;<a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_in_process_s_d_s_traits.html">InProcessSDSTraits</a>&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Type alias for a <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a> which works between threads in a single process. </p>

</div>
</div>
<h2 class="groupheader">Enumeration Type Documentation</h2>
<a id="a07d2a9441f40d089a1f9a0d7e2baab4b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07d2a9441f40d089a1f9a0d7e2baab4b">&#9670;&nbsp;</a></span>ReaderPolicy</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">alexaClientSDK::avsCommon::utils::sds::ReaderPolicy</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Specifies the policy to use for reading from the stream. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a07d2a9441f40d089a1f9a0d7e2baab4ba96aa07a625aac998fe9bd5cfd36a6880"></a>NONBLOCKING&#160;</td><td class="fielddoc"><p class="">A <code>NONBLOCKING</code> <code>Reader</code> will return any available data (up to the amount requested) immediately, without waiting for more data to be written to the stream. If no data is available, a <code>NONBLOCKING</code> <code>Reader</code> will return <code>Error::WOULDBLOCK</code>. </p>
</td></tr>
<tr><td class="fieldname"><a id="a07d2a9441f40d089a1f9a0d7e2baab4ba72323e5457d8fb855145bfee934aa415"></a>BLOCKING&#160;</td><td class="fielddoc"><p class="">A <code>BLOCKING</code> <code>Reader</code> will wait for up to the specified timeout (or forever if <code>(timeout == 0)</code>) for data to become available. As soon as at least one word is available, the <code>Reader</code> will return up to the requested amount of data. If no data becomes available in the specified timeout, a <code>BLOCKING</code> <code>Reader</code> will return <code>Error::TIMEDOUT</code>. </p>
</td></tr>
</table>

</div>
</div>
<a id="a7b17d768f16a6f5da766df780d94bbd5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b17d768f16a6f5da766df780d94bbd5">&#9670;&nbsp;</a></span>WriterPolicy</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">alexaClientSDK::avsCommon::utils::sds::WriterPolicy</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Specifies the policy to use for writing to the stream. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a7b17d768f16a6f5da766df780d94bbd5ad834d04fd76eafde1c8b4f6f95bdfdf8"></a>NONBLOCKABLE&#160;</td><td class="fielddoc"><p class="">A <code>NONBLOCKABLE</code> <code>Writer</code> will always write all the data provided without waiting for <code>Readers</code> to move out of the way.</p>
<dl class="section note"><dt>Note</dt><dd>: This policy causes the <code>Writer</code> to notify <code>BLOCKING</code> <code>Readers</code> about new data being available without holding a mutex. This means that a <code>read()</code> call may miss a notification and block when data is actually available. The assumption here is that a <code>NONBLOCKABLE</code> <code>Writer</code> will be frequently writing data, and a subsequent <code>write()</code> will again notify the <code>Reader</code> and wake it up. </dd></dl>
</td></tr>
<tr><td class="fieldname"><a id="a7b17d768f16a6f5da766df780d94bbd5a5d027622828a53a8fc66dd131952c8a1"></a>ALL_OR_NOTHING&#160;</td><td class="fielddoc"><p class="">An <code>ALL_OR_NOTHING</code> <code>Writer</code> will either write all the data provided if it can do so without overwriting unconsumed data, or it will return <code>Error::WOULDBLOCK</code> without writing any data at all.</p>
<dl class="section note"><dt>Note</dt><dd>: If there are no <code>Readers</code> attached, data can be written to a <code>ShardDataStream</code> until it fills up, but it will then stop accepting data from an <code>ALL_OR_NOTHING</code> <code>Writer</code> until a <code>Reader</code> attaches and consumes some of the data. However, there is a corner case where a <code>Reader</code> is attached, but has <code>seek()ed</code> into the future. In this scenario, all data written until the <code>Writer</code> catches up with the <code>Reader</code> will never be consumed, so the <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a></code> will allow an <code>ALL_OR_NOTHING</code> <code>Writer</code> to continue writing new data (and discarding old data) until it reaches the index the <code>Reader</code> is waiting for. </dd></dl>
</td></tr>
<tr><td class="fieldname"><a id="a7b17d768f16a6f5da766df780d94bbd5a72323e5457d8fb855145bfee934aa415"></a>BLOCKING&#160;</td><td class="fielddoc"><p class="">A <code>BLOCKING</code> <code>Writer</code> will wait for up to the specified timeout (or forever if <code>(timeout == 0)</code>) for space to become available. As soon as at least one word can be written, the <code>Writer</code> will write as many words as it can without overwriting unconsumed data, and return the number of words written. If no space becomes available in the specified timeout, a <code>BLOCKING</code> <code>Writer</code> will return <code>Error::TIMEDOUT</code>. </p>
</td></tr>
</table>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
